#ifndef __SERVDRV_LINUX_H__
#define __SERVDRV_LINUX_H__

typedef unsigned int LINUX_DRV_STATUS;

#define MSM_REGISTRY_PATH        "/opt/matrox_imaging/settings/"
#define MSM_REGISTRY_ASPM        "machine/system/currentcontrolset/services/mtxservmanager/parameters/forceaspmdisable"

#define MSM_IOCTL_FROM_USER   0
#define MSM_IOCTL_FROM_KERNEL 1

int MSMLinuxIoCtl(unsigned int cmd, void* SystemMsg, void *pDevice, int CalledFrom);

void MSMLinuxCreateDefaultObject(void *pDevObj);
void MSMLinuxInstanceCleanup(void *devObject);

void MSMLinuxSetASPMData(unsigned int ASPMDone, unsigned int ASPMFailed, unsigned int ASPMSeen);


LINUX_DRV_STATUS MSMLinuxReturnNoSys(void);

// we must include linuxentry.h after mtxservmanager.h if we need it
#ifndef __MTXSERVMANAGER_API_H__

typedef unsigned char      MSM_UINT8;
typedef char               MSM_INT8;
typedef unsigned short     MSM_UINT16;
typedef int                MSM_INT32;
typedef unsigned int       MSM_UINT32;

#if defined(__LP64__) || defined(__x86_64__)
typedef long               MSM_INT64;
typedef unsigned long      MSM_UINT64;
#else
typedef long long          MSM_INT64;
typedef unsigned long long MSM_UINT64;
#endif


typedef void*        MSM_HANDLE; // the MtxServManager handle is an hidden structure
typedef MSM_HANDLE* PMSM_HANDLE;

typedef MSM_UINT64   MSM_STATUS;


#ifdef __cplusplus
extern "C"
{
#endif

MSM_STATUS MSMAttach(PMSM_HANDLE opMSMHandle);
MSM_STATUS MSMDetach(MSM_HANDLE iMSMHandle);
MSM_STATUS MSMReadConfig(MSM_HANDLE iMSMHandle, MSM_UINT8 iBusNb, MSM_UINT8 iDevNb, MSM_UINT8 iFuncNb, MSM_UINT8 iRegNb, MSM_UINT8 iNumRegToRead, MSM_UINT32* opReadData);
MSM_STATUS MSMWriteConfig(MSM_HANDLE iMSMHandle, MSM_UINT8 iBusNb,MSM_UINT8 iDevNb, MSM_UINT8 iFuncNb, MSM_UINT8 iRegNb, MSM_UINT8 iNumRegToWrite, MSM_UINT32* ipWriteData);
MSM_STATUS MSMFindDevice(MSM_HANDLE iMSMHandle, MSM_UINT16 iVendorId, MSM_UINT16 iDeviceId, MSM_UINT8* iopBusNb, MSM_UINT8* iopDevNb, MSM_UINT8* iopFuncNb, MSM_UINT32 iIndex);
MSM_STATUS MSMFindDeviceEx(MSM_HANDLE iMSMHandle, MSM_UINT16 iVendorId, MSM_UINT16 iDeviceId, MSM_UINT16 iSubSystemId, MSM_UINT16 iSubVendorId, MSM_UINT8* iopBusNb, MSM_UINT8* iopDevNb, MSM_UINT8* iopFuncNb, MSM_UINT32 iIndex);
MSM_STATUS MSMRescanPCI(MSM_HANDLE iMSMHandle);
MSM_STATUS MSMGetBarSize(MSM_HANDLE iMSMHandle, MSM_UINT8 iBusNb, MSM_UINT8 iDevNb, MSM_UINT8 iFuncNb, MSM_UINT8 iRegNb, MSM_UINT64 * opBarSize);
MSM_STATUS MSMGetBarSizeFromRegistry(MSM_HANDLE iMSMHandle, char* ipName, MSM_UINT64 ipBarAddress[6], MSM_UINT64 opBarSize[6]);
MSM_STATUS MSMGetLicenseInfo(MSM_HANDLE iMSMHandle, void *iopLicenseInfo);
MSM_STATUS MSMAddLicenseInfo(MSM_HANDLE iMSMHandle, void *ipLicenseInfo);
MSM_STATUS MSMGetDriverInfo(MSM_HANDLE iMSMHandle, void *iopInfo);
MSM_STATUS MSMGetPciDeviceArray(MSM_HANDLE iMSMHandle, MSM_UINT32 *opNumDevice, void* opPCIArray);

#if MSM_API_DRIVER_CODE && MSM_API_USE_LINUX
int MtxServKernelIoctl (int cmd, void *msg);
#endif

#ifdef __cplusplus
}
#endif

#endif

#endif // __SERVDRV_LINUX_H__
